# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%{?!_mavenpomdir: %global _mavenpomdir %{_datadir}/maven2/poms}

%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%global alternativespriority 030000
%define reltag .Final_redhat_1
%define namedreltag .Final-redhat-1
%global apiname servlet
%global apiversion 3.0
%global apiversionu 3_0
%global plainversion %{version}%{?reltag}
%global namedversion %{version}%{?namedreltag}
%global apigroupid javax.servlet
%global apiartifactid %{apiname}-api

%define section free

%define maven_version 1.0.2.Final-redhat-1

Name:           jboss-%{apiname}-api_%{apiversion}_spec
Version:        1.0.2
Release:        1%{?reltag}%{?dist}
Epoch:          0
Summary:        Java API for XML-Based RPC (JAX-RPC) %{apiversion}
License:        LGPLv2+
URL:            http://fisheye.jboss.org/browse/JBossAS/projects/specs/tags/jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}
Group:          Development/Java

%if %with mead
Source100: org.jboss.spec.javax.servlet-jboss-servlet-api_3.0_spec-1.0.2.Final-redhat-1-sources.zip
Source101: org.jboss.spec.javax.servlet-jboss-servlet-api_3.0_spec-1.0.2.Final-redhat-1-patches.zip
Source102: jboss-servlet-api_3.0_spec-1.0.2.Final-redhat-1-javadoc.jar
Source103: jboss-servlet-api_3.0_spec-1.0.2.Final-redhat-1.jar
Source104: jboss-servlet-api_3.0_spec-1.0.2.Final-redhat-1.pom
Source105: jboss-servlet-api_3.0_spec-1.0.2.Final-redhat-1-sources.jar
%endif

%if 0
svn -q export -r 110833 http://anonsvn.jboss.org/repos/jbossas/projects/specs/tags/jboss-servlet-api_3.0_spec-1.0.0.Final
tar cjf jboss-servlet-api_3.0_spec-1.0.0.Final.tar.bz2 jboss-servlet-api_3.0_spec-1.0.0.Final
%endif
%if %without mead
Source0:        jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}.tar.bz2
Source1:        servlet-api-3.0.pom
Patch0:         jboss-servlet-api_3.0_spec-vman-pom.patch
%endif
Provides:       %{apiname}_%{apiversionu}_api
Provides:       %{apiname}_api = 0:%{apiversion}
Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
%if 0
Requires:       jboss-specs-parent >= 1.0.0-0.1.Beta2
%endif
%if %without mead
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-skins
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  jboss-parent
BuildRequires:  jboss-specs-parent >= 1.0.0-0.1.Beta2
BuildRequires:  jbossweb-servlet-2.5-api
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The JAX-RPC %{apiversion} API classes.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}
%patch0 -p1 -b .sav0
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file://`pwd`/maven2-brew
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} javadoc:javadoc javadoc:jar source:jar deploy site
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
pushd maven2-brew
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar %{buildroot}%{_javadir}
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}
%endif

# jar alternatives
/bin/touch %{buildroot}%{_javadir}/%{apiname}_api.jar
/bin/touch %{buildroot}%{_javadir}/%{apiname}_%{apiversionu}_api.jar

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
popd
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# pom alternatives
/bin/touch %{buildroot}%{_mavenpomdir}/JPP-%{apiname}_%{apiversionu}_api.pom
/bin/touch %{buildroot}%{_mavenpomdir}/JPP-%{apiname}_api.pom

# depmaps
%add_to_maven_depmap org.jboss.spec.javax.servlet jboss-%{apiname}-api_%{apiversion}_spec %{namedversion} JPP jboss-%{apiname}-api_%{apiversion}_spec
%add_to_maven_depmap %{apigroupid} %{apiartifactid} %{apiversion} JPP jboss-%{apiname}-api_%{apiversion}_spec

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%endif
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# javadoc alternatives
/bin/touch %{buildroot}%{_javadocdir}/%{apiname}_%{apiversionu}_api
/bin/touch %{buildroot}%{_javadocdir}/%{apiname}_api

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%{_sbindir}/update-alternatives --install %{_javadir}/%{apiname}_api.jar %{apiname}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_javadir}/%{apiname}_%{apiversionu}_api.jar %{apiname}_%{apiversionu}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_mavenpomdir}/JPP-%{apiname}_api.pom %{apiname}_api_pom %{_mavenpomdir}/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_mavenpomdir}/JPP-%{apiname}_%{apiversionu}_api.pom %{apiname}_%{apiversionu}_api_pom %{_mavenpomdir}/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom %{alternativespriority}
%update_maven_depmap

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar
    %{_sbindir}/update-alternatives --remove %{apiname}_api_pom %{_mavenpomdir}/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_pom %{_mavenpomdir}/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
fi

%postun
%update_maven_depmap

%post javadoc
%{_sbindir}/update-alternatives --install %{_javadocdir}/%{apiname}_api %{apiname}_api_javadoc %{_javadocdir}/%{name} %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_javadocdir}/%{apiname}_%{apiversionu}_api %{apiname}_%{apiversionu}_api_javadoc %{_javadocdir}/%{name} %{alternativespriority}

%preun javadoc
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api_javadoc %{_javadocdir}/%{name}
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_javadoc %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-sources.jar
%ghost %{_javadir}*/%{apiname}_%{apiversionu}_api.jar
%ghost %{_javadir}*/%{apiname}_api.jar
%{_mavenpomdir}/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
%ghost %{_mavenpomdir}/JPP-%{apiname}_%{apiversionu}_api.pom
%ghost %{_mavenpomdir}/JPP-%{apiname}_api.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-javadoc.jar
# FIXME: no alternatives for the javadoc jars
%ghost %{_javadocdir}/%{apiname}_api
%ghost %{_javadocdir}/%{apiname}_%{apiversionu}_api

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Feb 06 2013 Yong Yang <yyang@redhat.com> - 0:1.0.2-1.Final_redhat_1
- Upgrade to 1.0.2.Final

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-11.Final_redhat_2
- Rebuild for MD5

* Wed Sep 12 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-10
- remove source inclusion in mead mode
- use _mavenpomdir macro

* Thu Sep 06 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-9
- fix pom alternatives
- fix file list

* Mon Aug 20 2012 Honza Brazdil <jbrazdil@redhat.com> - 0:1.0.1-8.Final_redhat_2
- Update pom patch for eap 6.0.1

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-7.Final_redhat_2.1
- Rebuild unsigned

* Wed Aug 01 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-7
- fix update-alternatives call in %%post

* Wed Aug 01 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-6.Final_redhat_1.1
- Rebuild unsigned

* Wed Jul 25 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-6
- fix typos in %%post

* Fri Jul 20 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-5
- add back alternatives

* Thu Jul 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-4.Final_redhat_1.1
- Rebuild using cache signing

* Thu Jul 05 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-4
- fix bad requires
- fix broken maven support
- fix macro in comment
- remove javadoc jars to javadoc package
- fix Release tag

* Tue Jun 12 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-3
- enable mead option
- remove update-alternatives Requires from javadoc pkg
- fix depmap
- remove ghost from file list
- don't own javadoc dir in main pkg

* Thu May 31 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-2.Final_redhat_1
- Remove javadocs from main package and into their own RPM

* Fri Apr 20 2012 Lin Gao <lgao@redhat.com> 0:1.0.1-1.Final_redhat_1
- Upgrade to 1.0.1.Final

* Fri Mar 16 2012 Hui Wang <huwang@redhat.com> 0:1.0.0-9.Final_redhat_1.1
- New wrapper
- Fix installing path
- Fix release tag

* Thu Feb 09 2012 Lin Gao <lgao@redhat.com> 0:1.0.0-8
- re vman for pom patch
- rebuild for new sign key

* Wed Feb 01 2012 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-6
- Remove dependency on servlet_2_5_api

* Mon Jun 27 2011 Yong Yang <yyang@redhat.com> 0:1.0.0-5
- Fix relocation pom

* Mon Jun 27 2011 Yong Yang <yyang@redhat.com> 0:1.0.0-4
- Add relocation pom

* Fri Jun 24 2011 Yong Yang <yyang@redhat.com> 0:1.0.0-3
- Fix repolib location
- Fix pom name in repolib


* Fri Jun 24 2011 Yong Yang <yyang@redhat.com> 0:1.0.0-2
- First build

* Thu May 26 2011 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-1
- Adapted from jboss-jaxrpc_1.1_spec
